#include "animationbar.h"
#include <QRandomGenerator>
#include <QPropertyAnimation>
#include <QTimer>

#include <QDebug>

AnimationBar::AnimationBar(QWidget *parent) : QGraphicsView(parent)
{
    scene=new QGraphicsScene(this);
    this->setScene(scene);
    this->setRenderHints(QPainter::Antialiasing);
    this->setHorizontalScrollBarPolicy ( Qt::ScrollBarAlwaysOff );
    this->setVerticalScrollBarPolicy ( Qt::ScrollBarAlwaysOff );
    this->setStyleSheet("QGraphicsView{background-color:rgb(150,150,150);}");
    QTimer::singleShot(100,this,[&](){init();});
}
void AnimationBar::init(){
    mW = this->size().width();
    mH = this->size().height();
    scene->setSceneRect(0,0,mW,mH);
}

void AnimationBar::setPourcent(qreal pourc, bool isTimer){
    mColor = QColor(QRandomGenerator::global()->generate()%256,QRandomGenerator::global()->generate()%256,QRandomGenerator::global()->generate()%256);
    bar = new AnimationBarItem();
    bar->setBrush(QBrush(mColor));
    bar->setPen(QPen(QColor(0,0,0,0)));
    scene->clear();
    int ww=(double)(mW)*pourc/100.0;
    //bar->setRect(0,0,ww,mH);

    if (isTimer){
        /*
        if (mLoop!=nullptr){
            mLoop->stop();
        }else{
            mLoop=new QTimer(this);
            mLoop->setInterval(18);
            connect(mLoop,SIGNAL(timeout()),this,SLOT(animPourcent()));
        }
        mCurrent=0;
        mDest=pourc/100.0;
        mLoop->start();
        */
    }else{
        QPropertyAnimation *animation = new QPropertyAnimation(bar, "rect");
        //connect(animation, &QPropertyAnimation::valueChanged, [=](){qDebug() << this;});//update();});
        animation->setDuration(200);
        animation->setStartValue(QRect(0, 0, 0, mH));
        animation->setEndValue(QRect(0, 0, ww,mH));
        animation->start();
    }

    scene->addItem(bar);
}
/*
void AnimationBar::animPourcent(){
    mCurrent=mCurrent*0.8+0.2*mDest;
    if ((mDest-mCurrent)<0.1){
        mLoop->stop();
        mCurrent=mDest;
    }
    bar->setRect(QRect(0, 0, mW*mCurrent,mH));
}
*/
