#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include "simplewindow.h"

QT_BEGIN_NAMESPACE
namespace Ui { class MainWindow; }
QT_END_NAMESPACE

#include <QtWebEngineWidgets>

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    MainWindow(QWidget *parent = nullptr);
    ~MainWindow();

private slots:
    void createWebView(bool is);
    void createInternalWebView(bool is);
    void createExternalWebView(bool is);
    void killWebView(bool is);
    void webPageReady(bool ok);
    void runAnims(bool is);
    void fitExternalWebView();

    //void runTimers(bool is);
    //void pdfPrintingFinished(const QString &filePath, bool success);
    //void saveImage();

private:
    Ui::MainWindow *ui;

    QWebEnginePage* mWebEnginePage = nullptr;
    QWebEngineView* mWebEngineView = nullptr;
    QLayout* mLayoutForBrowse = nullptr;

    SimpleWindow* mPopup = nullptr;

protected:
    void moveEvent(QMoveEvent *e);
};
#endif // MAINWINDOW_H
